<?php
defined('_JEXEC') or die('Restricted access');

class pm_mellat extends PaymentRoot{
    
    function showPaymentForm($params, $pmconfigs){
        include(dirname(__FILE__)."/paymentform.php");
    }

	//function call in admin
	function showAdminFormParams($params){
	  $array_params = array('privateKey', 'merchantCode', 'terminalCode', 'transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
	  foreach ($array_params as $key){
	  	if (!isset($params[$key])) $params[$key] = '';
	  } 
	  $orders = &JModel::getInstance('orders', 'JshoppingModel'); //admin model
      include(dirname(__FILE__)."/adminparamsform.php");	  
	}

	function checkTransaction($pmconfigs, $order, $act){
        $jshopConfig = &JSFactory::getConfig();
include_once 'parser.php';
$result = post2https($_GET['tref'],'http://pgws.bpm.bankmellat.ir/pgwchannel/services/pgw?wsdl');
$array = makeXMLTree($result);
if($array["resultObj"]["result"] == 'True'){
return array(1, ''); 
}
else{
return array(0, 'تراکنش شما لغو شده است. شناسه تراکنش : '.$order->order_id);
}
	}

	function showEndForm($pmconfigs, $order){
        
        $jshopConfig = &JSFactory::getConfig();        
	    /*$item_name = sprintf(_JSHOP_PAYMENT_PRODUCT_IN_SITE, $jshopConfig->store_name);*/
        $item_name = sprintf(_JSHOP_PAYMENT_NUMBER, $order->order_number);
        $_country = &JTable::getInstance('country', 'jshop');
        $_country->load($order->country);
        $country = $_country->country_code_2;
		$notify_url = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&js_paymentclass=pm_mellat&no_lang=1";
        $redirectAddress = JURI::root(). "index.php?option=com_jshopping&controller=checkout&task=step7&act=return&itemnumber=".$order->order_id."&js_paymentclass=pm_mellat";
        $cancel_return = JURI::root() . "index.php?option=com_jshopping&controller=checkout&task=step7&act=cancel&js_paymentclass=pm_mellat";
		$Host=$_SERVER['HTTP_HOST'];
        require_once("RSAProcessor.class.php");
        $privateKey = $pmconfigs['privateKey'];
        $merchantCode = $pmconfigs['merchantCode'];
        $terminalCode = $pmconfigs['terminalCode'];
        $processor = new RSAProcessor("$privateKey",RSAKeyType::XMLFile);
        $invoiceDate = date("Y/m/d H:i:s");
		$timeStamp = date("Y/m/d H:i:s");
		$action = "1003";
		$invoiceNumber=$order->order_id;
		$data = "#". $merchantCode ."#". $terminalCode ."#". $invoiceNumber ."#". $invoiceDate ."#". $amount ."#". $redirectAddress ."#". $action ."#". $timeStamp ."#";
        $data = sha1($data,true);
        $data =  $processor->sign($data);
        $result =  base64_encode($data);
        ?>
        <html>
        <body>
        <head>
        <meta http-equiv="content-type" content="text/html; charset=utf-8" />            
        </head>
        <form id="paymentform" action="https://epayment.bankpasargad.com/gateway.aspx" name = "paymentform" method = "post"> 	
	    <input type='hidden' name='invoiceNumber' value='<?php print $invoiceNumber; ?>' /><br />
	    <input type='hidden' name='invoiceDate' value='<?php print $invoiceDate; ?>' /><br />
	    <input type='hidden' name='amount' value='<?php print round($order->order_total); ?>' /><br />
	    <input type='hidden' name='terminalCode' value='<?php print $terminalCode; ?>' /><br />
	    <input type='hidden' name='merchantCode' value='<?php print $merchantCode; ?>' /><br />
	    <input type='hidden' name='redirectAddress' value='<?php print $redirectAddress; ?>'/><br />
	    <input type='hidden' name='timeStamp' value='<?php print $timeStamp; ?>' /><br />
	    <input type='hidden' name='action' value='<?php print $action; ?>' /><br />
	    <input type='hidden' name='sign' value='<?php print $result; ?>' /><br />   
	    </form>   
        <?php print 'در حال ارسال به بانک'; ?>
        <br>
        <script type="text/javascript">document.getElementById('paymentform').submit();</script>
        </body>
        </html>
        <?php
        die();
	}
    
    function getUrlParams($pmconfigs){                        
        $params = array(); 
        $params['order_id'] = JRequest::getInt("itemnumber");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
    return $params;
    }
    
}
?>